local love = assert( love )
local lk = assert( love.keyboard )
local lg = assert( love.graphics )

local utf8 = assert( require 'utf8' )
local string = assert( string )


local _lt
local _lkp


local textInput = { }
local __mt = { __index = textInput }
local activeWidget

function textInput.new()
  return setmetatable( {text = ""}, __mt )
end

--This is only called when a text input widget is active.
function textInput.keypressed(key, code, isRepeat)
  assert( activeWidget )
  if code == "escape" then return textInput.escape() end
  if code == "return" then return textInput.return() end
  
  local text = activeWidget.text
  if code == "backspace" then
    local byteoffset = utf8.offset(text, -1)

    if byteoffset then
        -- remove the last UTF-8 character.
        -- string.sub operates on bytes rather than UTF-8 characters, so we couldn't do string.sub(text, 1, -2).
        text = string.sub(text, 1, byteoffset - 1)
    end
  end
end

function textInput:draw()
  lg.rectangle(  )
  lg.print(self.text, self.x or 0, self.y or 0)
end

function textInput:getText()
  return self.text
end

function textInput.textInput( s )
  activeWidget.text = activeWidget.text..s
end

function textInput:enable()
  _lt = love.textinput
  _lkp = love.keypressed
  love.textinput = textInput.textInput
  love.keypressed = textInput.keypressed
  activeWidget = self
end

function textInput:clear()
  
end

function textInput.disable()
  love.textinput = _lt
  love.
end

return textInput